SystemOrganization addCategory: #'SWE-IssueTracker'!

WAComponent subclass: #ITComponentAddIssue
	instanceVariableNames: 'title initialComment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 15:49'!
initialComment
	^ initialComment! !

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 15:49'!
initialComment: anObject
	initialComment := anObject! !

!ITComponentAddIssue methodsFor: 'rendering' stamp: 'mt 11/23/2007 19:15'!
renderContentOn: html
	html heading 
		level: 1;
		with: 'Add Issue'.
	html form: 
		[
		html text: 'Title'.
			html break.
		html textInput on: #title of: self.
			html break.
		html text: 'Description'.
			html break.
		html textArea on: #initialComment of: self.
			html break.
		html submitButton 
			callback: [ITIssueManager new addIssueWithTitle: self title withComment: self initialComment. self answer. ];
			value: 'add Issue'.
		html cancelButton
			callback: [self answer];
			value: 'cancel'.
		]! !

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 15:49'!
title
	^ title! !

!ITComponentAddIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 15:49'!
title: anObject
	title := anObject! !

WAComponent subclass: #ITComponentDetails
	instanceVariableNames: 'issue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentDetails class methodsFor: 'as yet unclassified' stamp: 'mt 11/23/2007 20:02'!
initializeWith: anIssue
	|view|
	view := self new.
	view issue: anIssue.
	^view.! !

!ITComponentDetails methodsFor: 'accessing' stamp: 'mt 11/23/2007 19:47'!
issue
	^ issue! !

!ITComponentDetails methodsFor: 'accessing' stamp: 'mt 11/23/2007 19:47'!
issue: anObject
	issue := anObject! !

!ITComponentDetails methodsFor: 'rendering' stamp: 'mfp 11/26/2007 16:53'!
renderContentOn: html
	html heading
		level: 2;
		with: 'detailed view of an issue'.
	html div
		with: [
			html text: self issue id.
			html break.
			html text: (self issue getTag: 'title').
			
			html break; break.
			html table: [
				(self issue comments) do: [:comment|
					html tableRow: [ html tableData: [ html text: comment ] ].

				]
			].
			html anchor
				callback: [self answer];
				with: [html text: 'return to list'].
		]
					
				! !

WAComponent subclass: #ITComponentListIssues
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentListIssues methodsFor: 'rendering' stamp: 'mfp 11/26/2007 15:54'!
renderContentOn: html
	| issues |
	issues := (ITIssueManager new) getIssues.
	html heading 
		level: 2;
		with: 'List all issues'.
	html form:[
		html table:[
			html tableRow: [
				html tableData: 'id'.
				html tableData: 'title'.
				html tableData: 'details'.
				html tableData: 'delete'.
				].
			issues do: [:issue|
				html tableRow: [
					html tableData: (issue id asString).
					html tableData: (issue getTag: 'title').
					html tableData: [
						html anchor 
							callback: [self call: (ITComponentDetails initializeWith: issue)];
							with: [html text: 'detailed view'].
						].
					html tableData: [
						html anchor
							callback: [((ITIssueManager new) deleteIssueWithID: issue id)];
							with: [html text: 'delete'].
						].
					].
				].
			].
		].! !

WAComponent subclass: #ITComponentMenu
	instanceVariableNames: 'listIssues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITComponentMenu class methodsFor: 'as yet unclassified' stamp: 'mt 11/23/2007 18:52'!
canBeRoot
	^true.! !

!ITComponentMenu methodsFor: 'initialize' stamp: 'mt 11/23/2007 19:05'!
children
	^Array with: self listIssues.! !

!ITComponentMenu methodsFor: 'initialize' stamp: 'mt 11/23/2007 19:05'!
initialize
	super initialize.
	self listIssues: ITComponentListIssues new.! !

!ITComponentMenu methodsFor: 'accessing' stamp: 'mt 11/23/2007 19:05'!
listIssues
	^ listIssues! !

!ITComponentMenu methodsFor: 'accessing' stamp: 'mt 11/23/2007 19:05'!
listIssues: anObject
	listIssues := anObject! !

!ITComponentMenu methodsFor: 'rendering' stamp: 'mt 11/23/2007 19:51'!
renderContentOn: html
	html heading
		level: 1;
		with: 'IssueTracker'.
	html anchor 
		callback: [ self call: ITComponentAddIssue new ]; 
		with: [ html text: 'add issue'].
	html div
		with: self listIssues.! !

Object subclass: #ITImageDB
	instanceVariableNames: ''
	classVariableNames: 'ISSUES NEXTID'
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITImageDB class methodsFor: 'as yet unclassified' stamp: 'afk 11/12/2007 16:11'!
connect

	^ self new.! !

!ITImageDB methodsFor: 'as yet unclassified' stamp: 'mfp 11/26/2007 16:39'!
addComment: aComment atID: id
	(ISSUES at: id) addComment: aComment.
! !

!ITImageDB methodsFor: 'Issues' stamp: 'afk 11/30/2007 14:17'!
addIssue: anIssue

	anIssue id: NEXTID.
	ISSUES at: anIssue id put: anIssue.
	NEXTID := NEXTID+1.
	
	^ self getIssueWithID: anIssue id.! !

!ITImageDB methodsFor: 'Issues' stamp: 'afk 11/30/2007 14:30'!
deleteIssueWithID: id
	ISSUES removeKey: id.! !

!ITImageDB methodsFor: 'Issues' stamp: 'afk 11/30/2007 14:14'!
getIssueWithID: id

	"I'm returning a copy of the ITIssue gequested by the given id"
	^ (ISSUES at: id) veryDeepCopy.! !

!ITImageDB methodsFor: 'Issues' stamp: 'afk 11/30/2007 14:24'!
getIssues
	^ ISSUES collect: [:anIssue | anIssue veryDeepCopy]! !

!ITImageDB methodsFor: 'initialize-release' stamp: 'afk 11/12/2007 16:25'!
initialize

	ISSUES ifNil: [ISSUES := Dictionary new].
	NEXTID ifNil: [NEXTID := 0].
	super initialize.! !

Object subclass: #ITIssue
	instanceVariableNames: 'id tags comments changelog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITIssue methodsFor: 'changing' stamp: 'afk 11/30/2007 14:55'!
addComment: aComment
	
	comments add: aComment.! !

!ITIssue methodsFor: 'accessing' stamp: 'mt 11/23/2007 19:55'!
comments
	^comments.! !

!ITIssue methodsFor: 'accessing' stamp: 'mfp 11/18/2007 16:41'!
getTag: tag
	^ tags at: tag ifAbsent: [^ nil].! !

!ITIssue methodsFor: 'accessing' stamp: 'afk 11/12/2007 16:20'!
id
	^ id! !

!ITIssue methodsFor: 'changing' stamp: 'afk 11/12/2007 16:20'!
id: anObject
	id := anObject! !

!ITIssue methodsFor: 'initialize-release' stamp: 'mig 11/30/2007 17:13'!
initialize
	
	changelog := OrderedCollection new.
	tags := Dictionary new.
	comments := OrderedCollection new.
	changelog := OrderedCollection new.
	super initialize.! !

!ITIssue methodsFor: 'changing' stamp: 'afk 11/12/2007 16:01'!
setTag: aTag to: aValue
	
	tags at: aTag put: aValue. ! !

Object subclass: #ITIssueComment
	instanceVariableNames: 'id content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITIssueComment methodsFor: 'accessing' stamp: 'mig 11/30/2007 17:18'!
content
	^ content! !

!ITIssueComment methodsFor: 'accessing' stamp: 'mig 11/30/2007 17:18'!
content: anObject
	content := anObject! !

!ITIssueComment methodsFor: 'accessing' stamp: 'mig 11/30/2007 17:18'!
id
	^ id! !

!ITIssueComment methodsFor: 'accessing' stamp: 'mig 11/30/2007 17:18'!
id: anObject
	id := anObject! !

!ITIssueComment methodsFor: 'initialize-release' stamp: 'mig 11/30/2007 17:17'!
initialize
	
	super initialize.! !

Object subclass: #ITIssueManager
	instanceVariableNames: 'database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITIssueManager methodsFor: 'accessing' stamp: 'mfp 11/26/2007 16:42'!
addComment: aComment atID: id

	database addComment: aComment atID: id.! !

!ITIssueManager methodsFor: 'changing' stamp: 'afk 11/12/2007 16:33'!
addIssueWithTitle: aTitle

	| anIssue |
	
	anIssue := ITIssue new.
	anIssue setTag: 'title' to: aTitle.
			
	^ database addIssue: anIssue. ! !

!ITIssueManager methodsFor: 'changing' stamp: 'afk 11/12/2007 16:30'!
addIssueWithTitle: aTitle withComment: aComment

	| anIssue |
	
	anIssue := ITIssue new.
	anIssue setTag: 'title' to: aTitle;
			addComment: aComment.
			
	^ database addIssue: anIssue. ! !

!ITIssueManager methodsFor: 'accessing' stamp: 'mfp 11/26/2007 15:28'!
deleteIssueWithID: id

	database deleteIssueWithID: id.
	! !

!ITIssueManager methodsFor: 'accessing' stamp: 'mfp 11/18/2007 16:52'!
getIssues
	^ database getIssues.! !

!ITIssueManager methodsFor: 'initialize-release' stamp: 'afk 11/12/2007 16:22'!
initialize
	
	database := ITImageDB connect.
	super initialize.! !

!ITIssueManager methodsFor: 'changing' stamp: 'afk 11/30/2007 14:38'!
saveChanges: anIssue

	! !

TestCase subclass: #ITTestImageDB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestImageDB methodsFor: 'testing' stamp: 'afk 11/12/2007 16:27'!
testAddIssue

	| newIssue db returningIssue |
	newIssue := ITIssue new.
	db := ITImageDB connect.
	returningIssue := db addIssue: newIssue.
	
	self assert: ( returningIssue isKindOf: ITIssue ) description: 'Returning Object is not kind of ITIssue'.
	self assert: ( returningIssue id notNil ) description: 'Returning ID is nil'.! !

!ITTestImageDB methodsFor: 'testing' stamp: 'afk 11/30/2007 14:21'!
testGetIssue
	
	"I'm testing wheter ImageDB is only returning a copy of the object or not."
	| db id |
	db := ITImageDB connect.
	id := db getIssues first id.
	
	self assert: ( (db getIssueWithID: id) ~~ (db getIssueWithID: id) ) description: 'ITImageDB is not giving only a copy of the Object'.! !

!ITTestImageDB methodsFor: 'testing' stamp: 'afk 11/30/2007 14:28'!
testGetIssues

	| db |
	db := ITImageDB connect.
	
	self assert: ( ((db getIssues) intersection: (db getIssues)) isEmpty ) description: 'Is not returning only a copy of the objects'.! !

TestCase subclass: #ITTestIssue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

TestCase subclass: #ITTestIssueManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWE-IssueTracker'!

!ITTestIssueManager methodsFor: 'testing' stamp: 'afk 11/12/2007 16:33'!
testAddIssue
	
	| IssueManager returningIssue |
	IssueManager := ITIssueManager new.
	
	returningIssue := IssueManager addIssueWithTitle: 'A Test Issue'.
	self assert: (returningIssue isKindOf: ITIssue) description: 'addIssue is not returning an Issue object'.
	! !

!ITTestIssueManager methodsFor: 'testing' stamp: 'mfp 11/26/2007 15:44'!
testDeleteIssue

	| IssueManager returningIssue issuelist |
	IssueManager := ITIssueManager new.
	
	returningIssue := IssueManager addIssueWithTitle: 'A Test Issue'.
	self assert: (returningIssue isKindOf: ITIssue) description: 'no issue present to delete'.
	IssueManager deleteIssueWithID: returningIssue id.
	issuelist := IssueManager getIssues select: [:issue | returningIssue id == issue id].
	self assert: (issuelist isEmpty).
	
	! !

!ITTestIssueManager methodsFor: 'testing' stamp: 'mfp 11/18/2007 17:23'!
testGetIssues
	
	| issueManager |
	issueManager := ITIssueManager new.
	
	issueManager getIssues do: [:issue|
		self assert: (issue isKindOf: ITIssue) description: 'not all returning objects are issues'].
	
	
	! !
